<?php
/**
 * @package     mod_pfeed
 *
 * @copyright   Copyright (C) 2005 - 2021 Jtotal. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
*/

defined('JPATH_PLATFORM') or die;


use JTFramework\JTlicense;
use JTFramework\JTfunc;
use JTFramework\JTdebug;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;


if (is_file(JPATH_PLUGINS . '/system/jtframework/autoload.php'))
{
    require_once JPATH_PLUGINS . '/system/jtframework/autoload.php';
}else{
    $app = Factory::getApplication();
    $app->enqueueMessage(Text::_('JT_FW_NOT_FOUND'), 'error');
    return;
}


class JFormFieldJtcheck extends JFormFieldText
{
    protected $type = 'jtcheck';


    protected function getLabel(){
        $mode = $this->element['mode'];
        if($mode == 'dashboard'){
            return;
        }
    }

    protected function getInput()
    {
        $field_set = $this->form->getFieldset();
        $params = $this->form->getValue('params');

        $valida = JTlicense::_checkLicense();

        $field_value = '';

        if($valida) $field_value .= $this->pro();
        if(!$valida) $field_value .= $this->lite();

        return $field_value;
    }



    private function lite(){

        JTlicense::disableFormsv3();


        $module_id = $this->form->getValue('id');
        $params = $this->form->getValue('params');

        if($params !== NULL){
           //$this->form->setValue('pfeedcomments','0');
            $params->pfeedcomments = '0';
            $params->pfeed_likes = '0';
            $params->pfeed_style = '0';
            $params->cache = '0';
            $params->pfeed_total_limit = '10';
        }else{
            return $this->mensajeLITE();
        }

        //consulta
        $reparams = $this->form->getValue('params');

        $encode_params = json_encode($reparams);

        $db = Factory::getDBO();
        $query = $db->getQuery(true);
        // Build the query
        $query->update('#__modules AS a');
        $query->set('a.params = ' . $db->quote((string)$encode_params));
        $query->where('a.id = '.$module_id);

        // Execute the query
        $db->setQuery($query);
        
        // Execute the query
        $db->setQuery($query);
        
        
        if(JTfunc::isJ4()){
            //v4
            $db->execute();
        }else{
            //v3
            $db->query();
        }


        return $this->mensajeLITE();


    }

    private function pro(){

             
            $field_value='';

            return $field_value;

    }

    private function mensajeLITE(){
        return '<div class="alert alert-info">'.Text::_('JT_FW_EXTENSIONS_SOME_VALUES_LITE').'</div>';
    }


}
