<?php
/**
 * @package     module mod_pfeed
 *
 * @copyright   Copyright (C) 2005 - 2021 Jtotal. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
*/
defined('_JEXEC') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Helper\ModuleHelper;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Profiler\Profiler;
use Joomla\CMS\Uri\Uri;

JLoader::register('modPfeedHelper', __DIR__ . '/helper.php');

$doc = Factory::getDocument();

$js_params = array();
$jsVariables = '';
$unique = htmlspecialchars('pfeed_' . $module->id);

$debug = $params->get('pfeed_debug','0');

if($debug){
	$profiler = new Profiler();
}



$client_id = $params->get('client_id','');
$user = $params->get('user','');
$cache = $params->get('cache','1');
$load_jquery = $params->get('load_jquery','1');
$load_bs = $params->get('load_basic_bootstrap','1');
$pfeed_auth = $params->get('access_token','');

if($pfeed_auth==""){
	echo '<div class="alert">Instagram auth token not defined. Please, go to PhotoFeed module settings and enter it.</div>';
	return;
}

if($user == ''){
	echo '<span class="alert">Instagram user empty</span>';
	return;
}


$license = $params->get('jtotal_license_value','0');


if(!$license){
	$params->pfeedcomments = '0';
	$params->pfeed_likes = '0';
	$params->pfeed_style = '0';
	$params->pfeed_license_activation = '0';
}

//OLD
//$load_fa = $params->get('pfeed_load_fa','1');


//design
$pfeed_total_limits = $params->get('pfeed_total_limit','20');
$pfeed_comments = $params->get('pfeedcomments','0');
$pfeed_likes = $params->get('pfeed_likes','0');
$pfeed_style_modern = $params->get('pfeed_style','1');
$pfeed_modern = $pfeed_style_modern ? 'modern' : 'basic';

//bootstrap
$bs_lg = $params->get('bs_lg','4');
$bs_max_lg = $params->get('bs_max_lg','0');
$bs_md = $params->get('bs_md','4');
$bs_max_md = $params->get('bs_max_md','0');
$bs_sm = $params->get('bs_sm','4');
$bs_max_sm = $params->get('bs_max_sm','0');
$bs_xs = $params->get('bs_xs','4');
$bs_max_xs = $params->get('bs_max_xs','0');

$thumbnail_size = $params->get('pfeed_thumbnail_size','thumbnail');


/*PHP TO JS*/

$bs_version = $params->get('bootstrap_version','3');
$doc->addScriptDeclaration("var php_bs_version = '{$bs_version}';");

$base = Uri::base();
$doc->addScriptDeclaration("var php_feed_base = '{$base}';");




/*
function loadSrcipts($name, $ruta){

	$doc = JFactory::getDocument();

	//load once scripts
	$scripts = array_keys($doc->_scripts);

	$scriptFound = false;
	for ($i = 0; $i < count($scripts); $i++) {
	    if (stripos($scripts[$i], $ruta) !== false) {
	        $scriptFound = true;
	    }
	}
	if (!$scriptFound) {

		$path = JURI::root(true) . $ruta;

		$doc->addScriptDeclaration('

			var pfeed_path = "'.$path.'";
			var pfeed_name = "'.$name.'";

	        (function(d, s, id) {
	           var js, fjs = d.getElementsByTagName(s)[0];
	          if (d.getElementById(id)) return;
	          js = d.createElement(s); js.id = id;
	          js.src = pfeed_path;
	          fjs.parentNode.insertBefore(js, fjs);
	        }(document, "script", pfeed_name));

		');
	}
}
*/



if($debug){
	$doc->addScript(URI::base().'media/mod_pfeed/js/pfeed.js', array(), array('defer'=>'defer'));
}else{
	$doc->addScript(URI::base().'media/mod_pfeed/js/pfeed.min.js', array(), array('defer'=>'defer'));
}






//SANDBOX
if($pfeed_total_limits=='0') $pfeed_total_limits=='20';


if($load_jquery){
	HTMLHelper::_('jquery.framework');
}




//* BOOTSTRAP JS
$load_bs_js = $params->get('load_bootstrap_js','1');

if($load_bs_js){

	if($load_bs_js == '1'){
		HTMLHelper::_('bootstrap.framework');
	}else{

		if($bs_version == '3'){
			$doc->addScript('https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js', 
				array(), 
				array('defer'=>'defer','crossorigin'=>'anonymous','referrerpolicy'=>'no-referrer','integrity'=>'sha384-aJ21OjlMXNL5UyIl/XNwTMqvzeRMZH2w8c5cRVpzpU8Y5bApTppSuUkhZXN0VxHd')
			);
		}

		if($bs_version == '4'){
			$doc->addScript('https://cdnjs.cloudflare.com/ajax/libs/bootstrap/4.6.1/js/bootstrap.bundle.min.js', 
				array(), 
				array('defer'=>'defer','crossorigin'=>'anonymous','referrerpolicy'=>'no-referrer','integrity'=>'sha512-mULnawDVcCnsk9a4aG1QLZZ6rcce/jSzEGqUkeOLy0b6q0+T6syHrxlsAGH7ZVoqC93Pd0lBqd6WguPWih7VHA==')
			);
		}

		if($bs_version == '5'){
			$doc->addScript('https://cdnjs.cloudflare.com/ajax/libs/bootstrap/5.1.3/js/bootstrap.bundle.min.js', 
				array(), 
				array('defer'=>'defer','crossorigin'=>'anonymous','referrerpolicy'=>'no-referrer','integrity'=>'sha512-pax4MlgXjHEPfCwcJLQhigY7+N8rt6bVvWLFyUMuxShv170X53TRzGPmPkZmGBhk+jikR8WBM4yl7A9WMHHqvg==')
			);
		}
	}

}



//* BOOTSTRAP CSS
if($load_bs){


	if($bs_version == '3'){
		$doc->addStyleSheet("https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css");
	}
	if($bs_version == '4'){
		$doc->addStyleSheet("https://cdnjs.cloudflare.com/ajax/libs/bootstrap/4.6.1/css/bootstrap.min.css");
	}

	if($bs_version == '5'){
		$doc->addStyleSheet("https://cdnjs.cloudflare.com/ajax/libs/bootstrap/5.1.3/css/bootstrap.min.css");
	}

}


$load_style = $params->get('pfeed_load_css','1');

if($load_style){
	$doc->addStyleSheet(URI::root(true)."/media/mod_pfeed/css/pfeed.css");
}


//BLUEIMP

if($params->get('pfeed_load_blueimp','1')){
	$doc->addStyleSheet(URI::root(true)."/media/mod_pfeed/blueimp/css/blueimp-gallery.min.css");
	$doc->addScript(URI::root(true).'/media/mod_pfeed/blueimp/js/jquery.blueimp-gallery.min.js', array(), array('defer'=>'defer'));
}


if($params->get('pfeed_load_lazy','1')){
	$doc->addScript(URI::root(true).'/media/mod_pfeed/js/lazysizes.min.js', array(), array('defer'=>'defer'));
}



//automatic mode
if($bs_max_lg == 0) $bs_max_lg = 12/$bs_lg;
if($bs_max_md == 0) $bs_max_md = 12/$bs_md;
if($bs_max_sm == 0) $bs_max_sm = 12/$bs_sm;
if($bs_max_xs == 0) $bs_max_xs = 12/$bs_xs;




if($debug){
	$tipo_input = 'text';
	$doc->addScriptDeclaration("var pfeed_debug = '{$debug}';");
}else{
	$tipo_input = 'hidden';
	$doc->addScriptDeclaration("var pfeed_debug = '{$debug}';");
}


//$pfeed_comments = $params->get('pfeedcomments','0');
$pfeed_likes = $params->get('pfeed_likes','0');

$pfeed_options = '<div class="pfeed_options pfeed_unique'.$module->id.'" moduleid="'.$module->id.'">';
	//$html .= '<input name="pfeed_next_url" type="text" class="pfeed_next_url" value="'.$next_url.'" />';

	//$pfeed_options .= '<input name="pfeed_auth" type="'.$tipo_input.'" class="pfeed_auth" value="'.$pfeed_auth.'" />';

	$pfeed_options .= '<input name="pfeed_user" type="'.$tipo_input.'" class="pfeed_user" value="'.$user.'" />';
	$pfeed_options .= '<input name="pfeed_max_id" type="'.$tipo_input.'" class="pfeed_max_id pfeed_required" value="" />';
	$pfeed_options .= '<input name="pfeed_license" type="hidden" class="pfeed_license" value="'.$license.'" />';
	
	$pfeed_options .= '<input name="pfeed_pagenum" type="'.$tipo_input.'" class="pfeed_pagenum" value="1" />';
	$pfeed_options .= '<input name="pfeed_element_num" type="'.$tipo_input.'" class="pfeed_element_num pfeed_required" value="0" />';
	$pfeed_options .= '<input name="pfeed_total_limit" type="'.$tipo_input.'" class="pfeed_total_limit" value="'.$pfeed_total_limits.'" />';

	$pfeed_options .= '<input name="pfeed_comments" type="'.$tipo_input.'" class="pfeed_comments" value="'.$pfeed_comments.'" />';
	$pfeed_options .= '<input name="pfeed_likes" type="'.$tipo_input.'" class="pfeed_likes" value="'.$pfeed_likes.'" />';

	$pfeed_options .= '<input name="pfeed_bs_lg" type="'.$tipo_input.'" class="pfeed_bs_lg" value="'.$bs_lg .'" />';
	$pfeed_options .= '<input name="pfeed_bs_max_lg" type="'.$tipo_input.'" class="pfeed_bs_max_lg" value="'.$bs_max_lg .'" />';
	
	$pfeed_options .= '<input name="pfeed_bs_md" type="'.$tipo_input.'" class="pfeed_bs_md" value="'.$bs_md .'" />';
	$pfeed_options .= '<input name="pfeed_bs_max_md" type="'.$tipo_input.'" class="pfeed_bs_max_md" value="'.$bs_max_md .'" />';
	
	$pfeed_options .= '<input name="pfeed_bs_sm" type="'.$tipo_input.'" class="pfeed_bs_sm" value="'.$bs_sm .'" />';
	$pfeed_options .= '<input name="pfeed_bs_max_sm" type="'.$tipo_input.'" class="pfeed_bs_max_sm" value="'.$bs_max_sm .'" />';
	$pfeed_options .= '<input name="pfeed_bs_xs" type="'.$tipo_input.'" class="pfeed_bs_xs" value="'.$bs_xs .'" />';
	$pfeed_options .= '<input name="pfeed_bs_max_xs" type="'.$tipo_input.'" class="pfeed_bs_max_xs" value="'.$bs_max_xs .'" />';

	$pfeed_options .= '<input name="pfeed_thumbnail_size" type="'.$tipo_input.'" class="pfeed_thumbnail_size" value="'.$thumbnail_size .'" />';

	$pfeed_options .= '<input name="pfeed_profile_img" type="'.$tipo_input.'" id="pfeed_profile_img'.$module->id.'" class="pfeed_profile_img pfeed_required" value="" />';
	$pfeed_options .= '<input name="pfeed_after" type="'.$tipo_input.'" id="pfeed_after'.$module->id.'" class="pfeed_after" value="" />';


$pfeed_options .= '</div>';

echo $pfeed_options;


$params_to_js = json_encode(array('params'=>$js_params));
$jsVariables .= "var php_pfeed_params_".$unique." = '{$params_to_js}';";


require ModuleHelper::getLayoutPath('mod_pfeed', $params->get('layout', 'default'));


if($debug){
	echo $profiler->mark('');
}